/*
 *  Delay.h
 *  oh_hw1_delay
 *
 *  Created by Jieun Oh on 1/9/10.
 *  Copyright 2010 Stanford University. All rights reserved.
 *
 */

#ifndef __DELAY_H__
#define __DELAY_h__	

#include <iostream>
#include "mo_def.h"
using namespace std;

class Delay
{
	public:

		Delay();
		Delay(int samples);
		void init(int samples);
		~Delay();
		
		SAMPLE getNextSample();  
		void writeToDelay( SAMPLE s );      // populates myDelay vector
		void print();						// for debugging, prints myDelay vector
		
		void setGain( float g);	
		float getGain();

		
	private:
		
		int myDelayLen;						// number of samples delayed
		long myReader; 
		long myWriter; 
	
		float myGain;						// feedback coefficient
		long myBufferLen;					// length of the circular buffer
		
		SAMPLE* myDelay;   
		void setDelayLen( int samples );	// sets amount of time delayed 
				
};

#endif
